# frozen_string_literal: true

# Copyright from 2019 Paulo Arruda (parrudaj at gmail dot com)
#
# Licensed under the Commons Clause + Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

require 'gotta/cli/command'

module Gotta
  module Serve
    module CLI
      class Serve < Gotta::CLI::Command::Base
        command 'serve'

        def run!
          require 'gotta/serve'
          Gotta::Serve.start!(self)
        end

        def scheme
          "http#{'s' if ssl}"
        end

        def port
          options '-p', '--port', default: 3000
        end

        def ssl
          flag '--ssl', default: false
        end

        def bind_address
          options '-b', '--bind-address', default: '0.0.0.0'
        end

        def environment
          options '-e', '--env', default: 'development'
        end
      end
    end
  end
end
